/* codegen.h
 * GNU as / Intel 386 32bit mode Code Generator 
 * Input: Stack-machine Opcodes
 * Output: Opcodes for Registers as Stack cache with Register renaming
 *
 * by Andre Adrian
 *
 * version 11jun2006
 */
 
// Assembler file heading and footing
void fileprologue();
void fileepilogue();

// variable definition
void declid();
void declint();
void declarrint(int elem);
void declchar();
void declarrchar(int elem);
void localint();
void localarrint(int elem);
void localchar();
void localarrchar(int elem);
void paramint();
void paramarrint();
void paramchar();
void paramarrchar();

// function definition
void funcid();
void funcprologue();
void funcepilogue();

// function and procedure call
void callid();
void callarg();
void callproc();
void callfunc();

// control structure
void thenjump();
void elsejump();
void endiflabel();
void whilelabel();
void dojump();
void breakjump();
void wendjump();

// assignment (variable storing)
void varid();
void assignarray();
void assign();
void retrn();
void retrnvalue();

// constant loading
void pushconst();
void pushchrconst();
void pushstrconst();

// variable loading
void arrayid();
void pushvar();
void pusharrayvar();

// compare operators
void eq();
void ne();
void lt();
void le();
void gt();
void ge();

// arithmetric operators
void add();
void sub();
void mul();
void div();
void mod();
void neg();

// boolean operators
void and();
void or();
void xor();
void not();
